package com.bgy.sms.config;

import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.http.HttpServletRequest;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 *  * @ClassName: IPUtil
 *  * @version 1.0 
 *  * @Desc: Ip工具类
 *  * @author huaping hu
 *  * @date 2016年6月1日下午5:26:56
 *  * @history v1.0
 *  *
 *  
 */
@Slf4j
public class IPUtil {


    /**
     *  
     * 描述：获取IP地址
     *
     * @param request
     * @return
     * @author huaping hu 
     * @date 2016年6月1日下午5:25:44
     */
    public static String getIpAddress(HttpServletRequest request) {

        String ip = request.getHeader("x-forwarded-for");

        if (ip == null || ip.length() == 0 || "nuknown".equalsIgnoreCase(ip)) {

            ip = request.getHeader("Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "nuknown".equalsIgnoreCase(ip)) {

            ip = request.getHeader("WL-Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "nuknown".equalsIgnoreCase(ip)) {

            ip = request.getRemoteAddr();
        }
        return ip;
    }

}