package com.bgy.util;

import com.alibaba.fastjson.JSONObject;

import javax.crypto.Cipher;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESedeKeySpec;
import javax.crypto.spec.IvParameterSpec;
import java.nio.charset.StandardCharsets;
import java.security.Key;
import java.security.spec.AlgorithmParameterSpec;
import java.util.Base64;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class CryptoUtils {
    private AlgorithmParameterSpec iv;
    private Key key;

    public CryptoUtils(String _DESkey, String _vi) throws Exception {
        DESedeKeySpec keySpec = new DESedeKeySpec(_DESkey.getBytes(StandardCharsets.UTF_8));
        iv = new IvParameterSpec(_vi.getBytes(StandardCharsets.UTF_8));
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("desede");
        key = keyFactory.generateSecret(keySpec);
    }


    public static void main(String[] args) throws Exception {

        Map<String, String> querMap = new HashMap<>();
        querMap.put("bipid", "888");
        CryptoUtils des = new CryptoUtils("BF7834FA210A407BA449A2B8", "BD162758");
        String encodeParam = des.encode(Objects.requireNonNull(JSONObject.toJSONString(querMap)));
        Map<String, String> paramMap = new HashMap<>();
        paramMap.put("package", encodeParam);
        paramMap.put("companyid", "3C877D40-DCB1-4304-AC50-242E032A761A");
        paramMap.put("channelid", "FHYMA");
        String retStr = HttpUtil.sendPost("https://xstest.bgy.com.cn/ApiBgyTest/MerchantAlliance/GetAccountLimit", JSONObject.toJSONString(paramMap));

        String test = "{\"bipId\":\"shenxiang11\"}";

        JSONObject retJson = JSONObject.parseObject(retStr);
        String packageInfo = retJson.getString("package");
        String decode = des.decode(packageInfo);


        System.out.println("" + test);
        System.out.println("" + des.encode(test));
        System.out.println("" + des.decode(des.encode(test)));

    }

    /**
     * CBC加密
     *
     * @return Base64编码的密文
     */
    public String encode(String data) throws Exception {
        Cipher enCipher = Cipher.getInstance("desede/CBC/PKCS5Padding");
        enCipher.init(Cipher.ENCRYPT_MODE, key, iv);
        byte[] pasByte = enCipher.doFinal(data.getBytes(StandardCharsets.UTF_8));
        return Base64.getEncoder().encodeToString(pasByte);
    }

    /**
     * CBC解密
     *
     * @return 明文
     */
    public String decode(String data) throws Exception {
        Cipher deCipher = Cipher.getInstance("desede/CBC/PKCS5Padding");
        deCipher.init(Cipher.DECRYPT_MODE, key, iv);
        byte[] pasByte = deCipher.doFinal(Base64.getDecoder().decode(data));

        return new String(pasByte, StandardCharsets.UTF_8);
    }
}